import matplotlib.pyplot as plt
import pandas as pd
list1 = [250]*5072
list2 = [500]*5072
list3 = [750]*5072
list4 = [1000]*5072

# Tender + total production
data1 = pd.read_csv('Sensitivity/Tender_bid/Operational_tender_hourly_HPC_250.csv')
data2 = pd.read_csv('Sensitivity/Tender_bid/Operational_tender_hourly_HPC_500.csv')
data3 = pd.read_csv('Sensitivity/Tender_bid/Operational_tender_hourly_HPC_750.csv')
data4 = pd.read_csv('Sensitivity/Tender_bid/Operational_tender_hourly_HPC_1000.csv')

fig, ax = plt.subplots()
ax.plot(data1['total production'], label='production for 250MW tender', linestyle='solid', color='mediumblue')
ax.plot(list1, linestyle='dashed', color='black')
ax.plot(data2['total production'], label='production for 500MW tender', linestyle='solid', color='green')
ax.plot(list2, linestyle='dashed', color='black')
ax.plot(data3['total production'], label='production for 750MW tender', linestyle='solid', color='darkslategrey')
ax.plot(list3, linestyle='dashed', color='black')
ax.plot(data4['total production'], label='production for 1000MW tender', linestyle='solid', color='orange')
ax.plot(list4, linestyle='dashed', color='black')
ax.set_xlabel('Time [hour]')
ax.set_ylabel('Production [MWh/h]')
ax.legend(loc='upper right')
ax.set_xlim((0, 72))
plt.show()

# solar max
data5 = pd.read_csv('Sensitivity/Capacity_max/Operational_solar_max_hourly_HPC_0.csv')
data6 = pd.read_csv('Sensitivity/Capacity_max/Operational_solar_max_hourly_HPC_100.csv')
data7 = pd.read_csv('Sensitivity/Capacity_max/Operational_solar_max_hourly_HPC_200.csv')
data8 = pd.read_csv('Sensitivity/Capacity_max/Operational_solar_max_hourly_HPC_300.csv')
data9 = pd.read_csv('Sensitivity/Capacity_max/Operational_solar_max_hourly_HPC_400.csv')
data10 = pd.read_csv('Sensitivity/Capacity_max/Operational_solar_max_hourly_HPC_500.csv')

fig, ax = plt.subplots()
ax.plot(data5['total production'], label='production for 0MW solar', linestyle='solid', color='mediumblue')
ax.plot(data6['total production'], label='production for 100MW solar', linestyle='solid', color='green')
ax.plot(data7['total production'], label='production for 200MW solar', linestyle='solid', color='darkslategrey')
ax.plot(data8['total production'], label='production for 300MW solar', linestyle='solid', color='orange')
ax.plot(data9['total production'], label='production for 400MW solar', linestyle='solid', color='tab:red')
ax.plot(data10['total production'], label='production for 500MW solar', linestyle='solid', color='lime')
ax.plot(list1, label='tender capacity', linestyle='dashed', color='black')
ax.set_xlabel('Time [hour]')
ax.set_ylabel('Production [MWh/h]')
ax.legend(loc='upper right')
ax.set_xlim((0, 72))
plt.show()

# wind max
data11 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_0.csv')
data12 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_100.csv')
data13 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_200.csv')
data14 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_300.csv')
data15 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_400.csv')
data16 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_500.csv')
data17 = pd.read_csv('Sensitivity/Capacity_max/Operational_wind_max_hourly_HPC_600.csv')

fig, ax = plt.subplots()
ax.plot(data11['total production'], label='production for 0MW wind', linestyle='solid', color='mediumblue')
ax.plot(data12['total production'], label='production for 100MW wind', linestyle='solid', color='green')
ax.plot(data13['total production'], label='production for 200MW wind', linestyle='solid', color='darkslategrey')
ax.plot(data14['total production'], label='production for 300MW wind', linestyle='solid', color='orange')
ax.plot(data15['total production'], label='production for 400MW wind', linestyle='solid', color='tab:red')
ax.plot(data16['total production'], label='production for 500MW wind', linestyle='solid', color='lime')
ax.plot(data17['total production'], label='production for 600MW wind', linestyle='solid', color='purple')
ax.plot(list1, label='tender capacity', linestyle='dashed', color='black')
ax.set_xlabel('Time [hour]')
ax.set_ylabel('Production [MWh/h]')
ax.legend(loc='upper right')
ax.set_xlim((0, 72))
plt.show()

# coal max
data18 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_0.csv')
data19 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_50.csv')
data20 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_100.csv')
data21 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_150.csv')
data22 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_200.csv')
data23 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_250.csv')
data24 = pd.read_csv('Sensitivity/Capacity_max/Operational_coal_max_hourly_HPC_300.csv')

fig, ax = plt.subplots()
ax.plot(data18['total production'], label='production for 0MW coal', linestyle='solid', color='mediumblue')
ax.plot(data19['total production'], label='production for 50MW coal', linestyle='solid', color='green')
ax.plot(data20['total production'], label='production for 100MW coal', linestyle='solid', color='darkslategrey')
ax.plot(data21['total production'], label='production for 150MW coal', linestyle='solid', color='orange')
ax.plot(data22['total production'], label='production for 200MW coal', linestyle='solid', color='tab:red')
ax.plot(data23['total production'], label='production for 250MW coal', linestyle='solid', color='lime')
ax.plot(data24['total production'], label='production for 300MW coal', linestyle='solid', color='purple')
ax.plot(list1, label='tender capacity', linestyle='dashed', color='black')
ax.set_xlabel('Time [hour]')
ax.set_ylabel('Production [MWh/h]')
ax.legend(loc='upper right')
ax.set_xlim((0, 72))
plt.show()

# power max
data25 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_0.csv')
data26 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_50.csv')
data27 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_100.csv')
data28 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_150.csv')
data29 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_200.csv')
data30 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_250.csv')
data31 = pd.read_csv('Sensitivity/Capacity_max/Operational_battery_max_hourly_HPC_300.csv')

fig, ax = plt.subplots()
ax.plot(data25['total production'], label='production for 0MW battery power', linestyle='solid', color='mediumblue')
ax.plot(data26['total production'], label='production for 50MW battery power', linestyle='solid', color='green')
ax.plot(data27['total production'], label='production for 100MW battery power', linestyle='solid', color='darkslategrey')
ax.plot(data28['total production'], label='production for 150MW battery power', linestyle='solid', color='orange')
ax.plot(data29['total production'], label='production for 200MW battery power', linestyle='solid', color='tab:red')
ax.plot(data30['total production'], label='production for 250MW battery power', linestyle='solid', color='lime')
ax.plot(data31['total production'], label='production for 300MW battery power', linestyle='solid', color='purple')
ax.plot(list1, label='tender capacity', linestyle='dashed', color='black')
ax.set_xlabel('Time [hour]')
ax.set_ylabel('Production [MWh/h]')
ax.legend(loc='upper right')
ax.set_xlim((0, 72))
plt.show()

# energy max
data32 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_0.csv')
data33 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_50.csv')
data34 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_100.csv')
data35 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_150.csv')
data36 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_200.csv')
data37 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_250.csv')
data38 = pd.read_csv('Sensitivity/Capacity_max/Operational_energy_max_hourly_HPC_300.csv')

fig, ax = plt.subplots()
ax.plot(data32['total production'], label='production for 0MWh battery energy', linestyle='solid', color='mediumblue')
ax.plot(data33['total production'], label='production for 50MWh battery energy', linestyle='solid', color='green')
ax.plot(data34['total production'], label='production for 100MWh battery energy', linestyle='solid', color='darkslategrey')
ax.plot(data35['total production'], label='production for 150MWh battery energy', linestyle='solid', color='orange')
ax.plot(data36['total production'], label='production for 200MWh battery energy', linestyle='solid', color='tab:red')
ax.plot(data37['total production'], label='production for 250MWh battery energy', linestyle='solid', color='lime')
ax.plot(data38['total production'], label='production for 300MWh battery energy', linestyle='solid', color='purple')
ax.plot(list1, label='tender capacity', linestyle='dashed', color='black')
ax.set_xlabel('Time [hour]')
ax.set_ylabel('Production [MWh/h]')
ax.legend(loc='upper right')
ax.set_xlim((0, 72))
plt.show()

